import java.io.*;
import java.net.*;
import java.util.*;

import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class WebTest {

    private static SimpleReporterAdapter stat
        = new SimpleReporterAdapter("appserver-sqe");
    private static String TEST_NAME = "test";

    private String testSuiteID;
    private String host;
    private String port;
    private String contextRoot;


    public WebTest(String[] args) {
        testSuiteID = args[0];
        host = args[1];
        port = args[2];
        contextRoot = args[3];
        TEST_NAME = testSuiteID;
    }
    
    public static void main(String[] args) {
        stat.addDescription("Jpa JTA Transaction with JNDI Lookup for EM");
        WebTest webTest = new WebTest(args);
        webTest.doTest();
        stat.printSummary(TEST_NAME);
    }

    public void doTest() {     
        try { 
            test1();
            test2();
        } catch (Exception ex) {
	    stat.addStatus(TEST_NAME, stat.FAIL);
            ex.printStackTrace();
        }
    }

    private void test1() throws Exception {
        String EXPECTED_RESPONSE = "JPA Example";
        String TEST_CASE = TEST_NAME + "jsp";
        String url = "http://" + host + ":" + port + contextRoot + "/index.jsp";
        System.out.println("url="+url);

        HttpURLConnection conn = (HttpURLConnection)
            (new URL(url)).openConnection();
        int code = conn.getResponseCode();
        if (code != 200) {
            System.err.println("Unexpected return code: " + code);
            stat.addStatus(TEST_CASE, stat.FAIL);
        } else {
            InputStream is = conn.getInputStream();
            BufferedReader input = new BufferedReader(new InputStreamReader(is));
	    String line = null;
	    while ((line = input.readLine()) != null) {
              // System.out.println("line="+line);
	      if (line.contains(EXPECTED_RESPONSE)) {
		stat.addStatus(TEST_CASE, stat.PASS);
		break;
	      }
	    }
	    
	    if (line == null) {
	      System.out.println("Unable to find " + EXPECTED_RESPONSE +
				  " in the response");
	    }
	    stat.addStatus(TEST_CASE, stat.FAIL);
        }    
    }

    private void test2() throws Exception {
        String EXPECTED_RESPONSE = "JpaTest:PASSED";
        String TEST_CASE = TEST_NAME + "servlet";
        String url = "http://" + host + ":" + port + contextRoot + "/jpa";
        System.out.println("url="+url);

        HttpURLConnection conn = (HttpURLConnection)
            (new URL(url)).openConnection();
        int code = conn.getResponseCode();
        if (code != 200) {
            System.err.println("Unexpected return code: " + code);
            stat.addStatus(TEST_CASE, stat.FAIL);
        } else {
            InputStream is = conn.getInputStream();
            BufferedReader input = new BufferedReader(new InputStreamReader(is));
	    String line = null;
	    while ((line = input.readLine()) != null) {
              // System.out.println("line="+line);
	      if (line.contains(EXPECTED_RESPONSE)) {
		stat.addStatus(TEST_CASE, stat.PASS);
		break;
	      }
	    }
	    
	    if (line == null) {
	      System.out.println("Unable to find " + EXPECTED_RESPONSE +
				  " in the response");
	    }
	    stat.addStatus(TEST_CASE, stat.FAIL);
        }    
    }

}


