package ejb3.war.servlet;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.PersistenceUnit;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;
import javax.persistence.EntityManager;
import javax.persistence.Query;

import javax.naming.InitialContext;

import javax.annotation.Resource;

import javax.transaction.UserTransaction;

import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.io.IOException;

public class JpaServlet extends HttpServlet {

    private EntityManager em;
    private UserTransaction utx;

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("text/plain");
        ServletOutputStream out = response.getOutputStream();
        Boolean persisted = false;

        try {

          InitialContext ic = new InitialContext();
          EntityManager em = (EntityManager) ic.lookup("java:comp/env/myem");
          // this option works for glassfish v2.1 and v3
          // utx = (UserTransaction) ic.lookup("java:comp/UserTransaction");
          // this option works for glassfish v2.1, and v3 on 03-31-2008 
          utx = (UserTransaction) ic.lookup("UserTransaction");

          out.println("Lookup, UserTransaction=" + utx);
          out.println("em =" + em);

	  JpaBean jpaBean = new JpaBean();
	  jpaBean.setName("JpaBean");
	  utx.begin();
	  em.persist(jpaBean);
	  utx.commit();

	  utx.begin();
	  Query query = em.createQuery("SELECT j FROM JpaBean j WHERE j.name='JpaBean'");
	  jpaBean = (JpaBean) query.getSingleResult();
	  out.println("Loaded " + jpaBean);
	  em.remove(jpaBean);
	  utx.commit();

	  query = em.createQuery("SELECT count(j) FROM JpaBean j WHERE j.name='JpaBean'");
	  int count = ((Number) query.getSingleResult()).intValue();
	  if (count == 0 ) {
            out.println("Removed " + jpaBean);
            out.println("JpaTest:PASSED");
	  } else {
            out.println("ERROR: unable to remove" + jpaBean);
            out.println("JpaTest:FAILED");
	  }

        }catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("servlet test failed");
            throw new ServletException(ex);
        }

    }
}






